image: openjdk:17
stages:
  - build
  - test
  - deploy

build:
  stage: build
  script:
    - chmod +x ./mvnw
    - ./mvnw package
  artifacts:
    paths:
      - weather-api-service/target/weather-api-service-0.0.1-SNAPSHOT.jar

test:
  stage: test
  script:
    - chmod +x ./mvnw
    - ./mvnw test

deploy:
  stage: deploy
  image: ruby:latest
  script:
    - apt-get update -qy
    - apt-get install -y ruby-dev
    - gem install dpl
    - dpl --provider=heroku --app=weather-api-service --api-key=$HEROKU_API_KEY
  only:
    - main